
import java.nio.ByteBuffer;
import java.util.ArrayList;

public class SADERevA {

	LibRS232 rs232 = new LibRS232();
	 
	
public SADERevA(){
	
	
}	
		
	private final byte comando_led = 0x21;
	private final byte comando_adc = 0x27;
	private final byte comando_iic_write = 0x23;
	private final byte comando_iic_read = 0x24 ;
	private final byte comando_sw = 0x22;
	private final byte comando_biport_out = 0x31;
	private final byte comando_biport_in = 0x32;
	private final byte comando_dac = 0x30;
	private final byte comando_rs232_write =0x25;
	private final byte comando_rs232_read =0x26;
	//Nuevos IPs
    private byte comando_leerultrasonico = 0x33;
    private byte comando_timer = 0x34 ;
    private byte comando_generador = 0x38 ;
	/**
	 * Pin de entrada salida y ultrasnico en Symbhia
	 */
	public final byte G1_Sy = (byte)0x81;
	/**
	 * Pin de entrada salida y ultrasnico en Symbhia
	 */
	public final byte F1_Sy = (byte)0x82;
	/**
	 * Pin de entrada salida y ultrasnico en Symbhia
	 */
	public final byte E1_Sy = (byte)0x83;
	/**
	 * Pin de entrada salida y ultrasnico en Symbhia
	 */
	public final byte F3_Sy = (byte)0x84;
	/**
	 * Pin de entrada salida y notificacin de Timer en Symbhia
	 */
	public final byte B3_Sy = (byte)0x85;
	/**
	 * Pin de entrada salida y notificacin de Timer en Symbhia
	 */
	public final byte A3_Sy = (byte)0x86;
	/**
	 * Pin de entrada salida y notificacin de Timer en Symbhia
	 */
	public final byte A4_Sy = (byte)0x87;
	/**
	 * Pin de entrada salida y notificacin de Timer en Symbhia
	 */
	public final byte B5_Sy = (byte)0x88;
	/**
	 * Pin de entrada salida y disparo externo (Noti en B3) en Symbhia
	 */
	public final byte A5_Sy = (byte)0x89;
	/**
	 * Pin de entrada salida y disparo externo (Noti en A3) en Symbhia
	 */
	public final byte A6_Sy = (byte)0x8A;
	/**
	 * Pin de entrada salida y disparo externo (Noti en A4) en Symbhia
	 */
	public final byte C6_Sy = (byte)0x8B;
	/**
	 * Pin de entrada salida y disparo externo (Noti en B5) en Symbhia
	 */
	public final byte A7_Sy = (byte)0x8C;
	/**
	 * Pin de entrada salida en Symbhia
	 */
	public final byte B7_Sy = (byte)0x8D;
	
	
	/**
	 * Pin de entrada salida y ultrasnico en Avanxe Verde
	 */
	public final byte M15_AvV = (byte)0x81;
	/**
	 * Pin de entrada salida y ultrasnico en Avanxe Verde
	 */
	public final byte N16_AvV = (byte)0x82;
	/**
	 * Pin de entrada salida y ultrasnico en Avanxe Verde
	 */
	public final byte P16_AvV = (byte)0x83;
	/**
	 * Pin de entrada salida y ultrasnico en Avanxe Verde
	 */
	public final byte R16_AvV = (byte)0x84;
	/**
	 * Pin de entrada salida y ultrasnico en Avanxe Verde
	 */
	public final byte P15_AvV = (byte)0x85;
	/**
	 * Pin de entrada salida y ultrasnico en Avanxe Verde
	 */
	public final byte R12_AvV = (byte)0x86;
	/**
	 * Pin de entrada salida y ultrasnico en Avanxe Verde
	 */
	public final byte N12_AvV = (byte)0x87;
	/**
	 * Pin de entrada salida y ultrasnico en Avanxe Verde
	 */
	public final byte P12_AvV = (byte)0x88;
	/**
	 * Pin de entrada salida y notificacin de Timer en Avanxe Verde
	 */
	public final byte M16_AvV = (byte)0x89;
	/**
	 * Pin de entrada salida y notificacin de Timer en Avanxe Verde
	 */
	public final byte C16_AvV = (byte)0x8A;
	/**
	 * Pin de entrada salida y notificacin de Timer en Avanxe Verde
	 */
	public final byte D16_AvV = (byte)0x8B;
	/**
	 * Pin de entrada salida y notificacin de Timer en Avanxe Verde
	 */
	public final byte E12_AvV = (byte)0x8C;
	/**
	 * Pin de entrada salida y disparo externo (Noti en M12) en Avanxe Verde
	 */
	public final byte E13_AvV = (byte)0x8D;
	/**
	 * Pin de entrada salida y disparo externo (Noti en C16) en Avanxe Verde
	 */
	public final byte E15_AvV = (byte)0x8E;
	/**
	 * Pin de entrada salida y disparo externo (Noti en D16) en Avanxe Verde
	 */
	public final byte F13_AvV = (byte)0x8F;
	/**
	 * Pin de entrada salida y disparo externo (Noti en E12) en Avanxe Verde
	 */
	public final byte E14_AvV = (byte)0x90;
	
	
	/**
	 * Pin de entrada salida y ultrasnico en Avanxe Azul
	 */
	public final byte A6_AvA = (byte)0x81;
	/**
	 * Pin de entrada salida y ultrasnico en Avanxe Azul
	 */
	public final byte C7_AvA = (byte)0x82;
	/**
	 * Pin de entrada salida y ultrasnico en Avanxe Azul
	 */
	public final byte B8_AvA = (byte)0x83;
	/**
	 * Pin de entrada salida y ultrasnico en Avanxe Azul
	 */
	public final byte C9_AvA = (byte)0x84;
	/**
	 * Pin de entrada salida y ultrasnico en Avanxe Azul
	 */
	public final byte F9_AvA = (byte)0x85;
	/**
	 * Pin de entrada salida y ultrasnico en Avanxe Azul
	 */
	public final byte A9_AvA = (byte)0x86;
	/**
	 * Pin de entrada salida y ultrasnico en Avanxe Azul
	 */
	public final byte D11_AvA = (byte)0x87;
	/**
	 * Pin de entrada salida y ultrasnico en Avanxe Azul
	 */
	public final byte E10_AvA = (byte)0x88;
	/**
	 * Pin de entrada salida y notificacin de Timer en Avanxe Azul 
	 */
	public final byte C13_AvA = (byte)0x89;
	/**
	 * Pin de entrada salida y notificacin de Timer en Avanxe Azul
	 */
	public final byte D12_AvA = (byte)0x8A;
	/**
	 * Pin de entrada salida y notificacin de Timer en Avanxe Azul
	 */
	public final byte B12_AvA = (byte)0x8B;
	/**
	 * Pin de entrada salida y notificacin de Timer en Avanxe Azul
	 */
	public final byte A11_AvA = (byte)0x8C;
	/**
	 * Pin de entrada salida y disparo externo (Noti en C13) en Avanxe Azul
	 */
	public final byte E15_AvA = (byte)0x8D;
	/**
	 * Pin de entrada salida y disparo externo (Noti en D12) en Avanxe Azul
	 */
	public final byte A14_AvA = (byte)0x8E;
	/**
	 * Pin de entrada salida y disparo externo (Noti en B12) en Avanxe Azul
	 */
	public final byte F16_AvA = (byte)0x8F;
	/**
	 * Pin de entrada salida y disparo externo (Noti en A11) en Avanxe Azul
	 */
	public final byte F15_AvA = (byte)0x90;
	
	//Timers disponibles
	/**
	 * Timer 1.
	 */
    public byte Timer1 = 0x35;
    /**
     * Timer 2.
     */
    public byte Timer2 = 0x36;
    /**
     * Timer 3.
     */
    public byte Timer3 = 0x37;
    /**
     * Timer 4.
     */
    public byte Timer4 = 0x39;


    /**
     * Genera onda Senoidal.
     */
    public String Onda_Senoidal = "Senoidal";
    /**
     * Genera onda Cuadrada.
     */
    public String Onda_Cuadrada = "Cuadrada";
    /**
     * Genera onda Diente de Sierra.
     */
    public String Onda_DienteSierra = "DienteSierra";
    /**
     * Genera onda Triangular.
     */
    public String Onda_Triangular = "Triangular";


/**
 * <p>Mtodo que envia informacin a LEDs de kit de desarrollo<p>
 * @param VALOR_A_LEDS - Byte con informacin que se quiera enviar a los LEDs
 */
public void LEDS(byte VALOR_A_LEDS){
	rs232.RS232EnviaBytes(new byte[] {comando_led},1);
	rs232.RS232EnviaBytes(new byte[] {VALOR_A_LEDS},1);	
}

/**
 *<p> Mtodo para la adquisicin de una seal analgica.<p>
 *<p> En Avanxe slo existe un canal analgico por lo que CANAL siempre debe ser = 1 <p>
 * @param CANAL - El canal del que se quiere obtener la conversin. Siempre 1
 * @return Byte con la informacin adquirida
 */
public byte ADC(int CANAL){
		
	rs232.RS232EnviaBytes(new byte[]{(byte) (0)}, 1);
	rs232.RS232EnviaBytes(new byte[] {comando_adc},1);
	byte[] VALOR_ADC = rs232.RS232LeerBytes(1);
	
	return VALOR_ADC[0];
}

/**
 * <p>Mtodo para la escritura mediante protocolo I2C<p>
 * @param SLAVE_ADDRESS - Byte con la direccin esclava del dispositivo<p>
 * @param REG_ADDRESS - Byte con la direccin del registro a escribir<p>
 * @param REG_DATA - Byte con el dato a escribir en el registro<p>
 */
public void I2C_Write(byte SLAVE_ADDRESS, byte REG_ADDRESS, byte REG_DATA){			
		
		byte[] BYTE_COMP0 = {comando_iic_write,SLAVE_ADDRESS,REG_ADDRESS,REG_DATA};
		rs232.RS232EnviaBytes(BYTE_COMP0, 4);
		rs232.RS232LeerBytes(1);
}

/**
 * <p>Mtodo para la lectura mediante protocolo I2C<p>
 * @param SLAVE_ADDRESS - Byte con la direccin esclava del dispositivo<p>
 * @param REG_ADDRESS - Byte con la direccin del registro a leer<p>
 * @return Byte con la informacin del registro<p>
 */
public byte[] I2C_Read(byte SLAVE_ADDRESS, byte REG_ADDRESS){
	
		byte[] BYTE_COMP1 = {comando_iic_read,SLAVE_ADDRESS,REG_ADDRESS};
		rs232.RS232EnviaBytes(BYTE_COMP1,3);
		byte[] VALOR_I2C = rs232.RS232LeerBytes(1);	
	
		return VALOR_I2C;
}

/**
 * <p>Mtodo que lee el valor de los switches de kit de desarrollo<p>
 * @return Byte con la informacin de los switches
 */
public byte SW(){
	
	byte[] SW={comando_sw};
	rs232.RS232EnviaBytes(SW,1);
	byte[] VALOR_SW = rs232.RS232LeerBytes(1);
	
	return VALOR_SW[0];
}

/**
 *<p> Mtodo que configura los pines para utilizarlos como PWM<p>
 * @param PERIODO_PWM - Valor del periodo, se calcula como:<p>
 * 						<i><tt>PERIODO_PWM = TIEMPO_PERIODO * 50,000,000</tt></i><p>
 * @param CICLO_PWM - Valor del ciclo de trabajo, se calcula como:<p>
 * 						<i><tt>CICLO_PWM = TIEMPO_CICLO * 50,000,000</tt></i><p>
 * @param PIN_FPGA - Pin que se utilizar como PWM
 */
public void PWM(int PERIODO_PWM,int CICLO_PWM,byte PIN_FPGA){
	
	byte[] BYTE_P = ByteBuffer.allocate(4).putInt(PERIODO_PWM).array();
	byte[] BYTE3_P={(byte)PIN_FPGA,2,BYTE_P[1],BYTE_P[2],BYTE_P[3]};
	rs232.RS232EnviaBytes(BYTE3_P,5);
	
	
	byte[] BYTE_C = ByteBuffer.allocate(4).putInt(CICLO_PWM).array();
	byte[] BYTE3_C={(byte)PIN_FPGA,4,BYTE_C[1],BYTE_C[2],BYTE_C[3]};
	rs232.RS232EnviaBytes(BYTE3_C,5);
	
}

/**
 *<p> Mtodo para utilizar uno de los pines disponibles como salida
 * @param PIN_FPGA - Nombre del pin a utilizar como salida<p>
 * @param VALOR - Valor tipo booleano para mandar un '1' o un '0' lgico<p>
 * 				  <i><tt>True = '1'</tt></i>
 * 				  <i><tt><BR>False = '0'</tt></i>
 */
public void Pin_Out(byte PIN_FPGA,boolean VALOR){
	
	rs232.RS232EnviaBytes(new byte[]{PIN_FPGA,(byte)((VALOR == true) ? 16 : 0)},2);

}

/**
 * <p>Mtodo para utilizar uno de los pines disponibles como entrada<p>
 * @param PIN_FPGA - Nombre del pin a utilizar como salida
 * @return Byte con lectura hecha en el pin, solo toma los valores de 0x00 y 0x01
 */
public byte Pin_In(byte PIN_FPGA){
	
	
	rs232.RS232EnviaBytes(new byte[]{PIN_FPGA,1},2);
	byte[] VALOR_PIN = rs232.RS232LeerBytes(1);	
	
	return VALOR_PIN[0];	
}

/**
 *<p> Mtodo para utilizar el puerto bidireccional como salida<p>
 * @param BYTE_A_ESCRIBIR - Byte con la informacin que se mandar a travs del puerto
 */
public void BiPort_Out(byte BYTE_A_ESCRIBIR){
	
	rs232.RS232EnviaBytes(new byte[]{comando_biport_out,BYTE_A_ESCRIBIR},2);
	
}

/**
 *<p> Mtodo para utilizar el puerto bidireccional como entrada<p>
 * @return Byte con la lectura hecha en el puerto
 */
public byte BiPort_In(){
	
	rs232.RS232EnviaBytes(new byte[]{comando_biport_in},1);
	
	byte[] VALOR_BPORT = rs232.RS232LeerBytes(1);	
	
	return VALOR_BPORT[0];
	
}

/**
 * <p>Mtodo para realizar una conversin digital-analgica cuyo voltaje de salida va de 0V a 4.08V<p>
 * @param VALOR_DAC - Byte con el valor digital.
 * 					 <p>La frmula para la conversin es: 
 * 					 <p><i><tt>VOLTAJE_SALIDA = VALOR_DAC * 0.016 </tt></i>
 * 
 */
public void DAC(byte VALOR_DAC){
	
	rs232.RS232EnviaBytes(new byte[]{comando_dac,VALOR_DAC},2);
	
}

/**
 * <p>Envio de un byte mediante protocolo RS232.
 * <HB>Velocidad de transmisin: 9600 baudios.<p>
 * @param DATO - Byte a enviar
 */

public void RS232_SADE_Write(byte DATO)
{
	rs232.RS232EnviaBytes(new byte[]{comando_rs232_write,DATO},2);
}


/**
 * <p>Recepcin de un byte mediante protocolo RS232.
 * <HB>Velocidad de transmisin: 9600 baudios.<p>
 * @return Byte con la informacin recibida.
 */
public byte RS232_SADE_Read()
{
	rs232.RS232EnviaBytes(new byte[]{comando_rs232_read},1);
	byte[] DATO = rs232.RS232LeerBytes(1);
	return DATO[0];
}

/**
 * <p>Mtodo para hacer obtener la distancia que devuelve un sensor ultrasnico HC-SR04. Se debe seleccionar un pin para el Trigger y uno para el Eco.<p>
 * <p>Pines en Symbhia: G1, F1, E1, F3.<p>
 * <p>Pines en Avanxe verde: M15, N16, P16, R16, P15, R12, N12, P12.<p>
 * <p>Pines en Avanxe azul: A6, C7, B8, C9, F9, A9, D11, E10.<p>
 * 
 * @param Pin_Trigger - Pin de la FPGA para utilizarlo como Trigger
 * @param Pin_Eco -  Pin de la FPGA conectado al ECO del sensor
 * @return Distancia en centmetros - Distancia en centmetros
 */
public int Leer_Ultrasonico(byte Pin_Trigger, byte Pin_Eco)
{
    byte[] Buffer = { Pin_Trigger,8,Pin_Eco,1};
    rs232.RS232EnviaBytes(Buffer,4);
    rs232.RS232LeerBytes(1);
    rs232.RS232EnviaBytes(new byte[] { comando_leerultrasonico }, 1);
    byte[] b1 = rs232.RS232LeerBytes(1);
    byte[] b2 = rs232.RS232LeerBytes(1);
    int DatoUltrasonico = b1[0] << 8 | b2[0];
    return DatoUltrasonico;
}


/**
 * Mtodo para utilizar un Timer controlado por Hardware en Modo 1.
 * @param Timer - Timer a utilizar en modo 1
 * @param Tiempo - Tiempo que deber transcurrir antes de mandar la notificacin
 * @param Escala_Tiempo - Escala del tiempo en microsegundos (us), milisegundos (ms), segundos(s)
 * @return True cuando haya transcurrido el tiempo especificado
 */
public boolean Timer_Modo1(byte Timer, int Tiempo, String Escala_Tiempo)
{
    
    boolean Fin = false;
    int t = 0;
    
    switch (Escala_Tiempo)
    {
        case "us":
            t = Tiempo * 50;
            break;
        case "ms":
            t = Tiempo * 50000;
            break;
        case "s":
            t = Tiempo * 50000000;
            break;
    }

    byte[] Abyte = ByteBuffer.allocate(4).putInt(t).array();
    byte[] Buffer = { comando_timer, Timer, Abyte[0], Abyte[1], Abyte[2], Abyte[3], 0 };
    rs232.RS232EnviaBytes(Buffer, 7);    
    byte[] fin = rs232.RS232LeerBytes(1);
    Fin = (fin[0]==1)? true:false;
    return Fin;
}

/**
 * Reinicia el Timer en modo 1.
 * @param Timer - Timer a reiniciar
 */
public void Reset_Timer_Modo1(byte Timer){
	//rs232.RS232Flush();
	byte[] Buffer = { comando_timer, Timer, 0, 0, 0, 0, 1 };
    rs232.RS232EnviaBytes(Buffer, 7);    
    rs232.RS232LeerBytes(1);
    rs232.RS232EnviaBytes(Buffer, 7);    
    rs232.RS232LeerBytes(1);
}


/**
 * <P>Mtodo para utilizar un Timer controlado por Hardware en Modo 2.<P>
 * 
 * <P>Pines en Symbhia: B3, A3, A4, B5.<P>
 * <P>Pines en Avanxe verde: M16, C16, D16, E12.<P>
 * <P>Pines en Avanxe azul: C13, D12, B12, A11.<P>
 * @param PinFPGA - Pin de la FPGA en donde se mostrar la notificacin
 * @param Tiempo - Tiempo que deber transcurrir antes de mandar la notificacin
 * @param Escala_Tiempo - Escala del tiempo en microsegundos (us), milisegundos (ms), segundos(s)
 * @return True cuando haya transcurrido el tiempo especificado 
 */
public boolean Timer_Modo2(byte PinFPGA, int Tiempo, String Escala_Tiempo)
{
    boolean Fin = false;
    int t = 0;

    switch (Escala_Tiempo)
    {
        case "us":
            t = Tiempo * 50;
            break;
        case "ms":
            t = Tiempo * 50000;
            break;
        case "s":
            t = Tiempo * 50000000;
            break;
    }

    byte[] Abyte = ByteBuffer.allocate(4).putInt(t).array();
    byte[] Buffer = { PinFPGA, 10, Abyte[0], Abyte[1], Abyte[2], Abyte[3], 0 };
    rs232.RS232EnviaBytes(Buffer, 7);
    byte[] fin = rs232.RS232LeerBytes(1);
    Fin = (fin[0] == 1) ? true : false;
    return Fin;
}

/**
 * Resetea el Timer en modo 2
 * @param PinFPGA - Pin de la FPGA utilizado como Timer
 */
public void Reset_Timer_Modo2(byte PinFPGA)
{
    byte[] Buffer = { PinFPGA, 10, 0, 0, 0, 0, 2 };
    rs232.RS232EnviaBytes(Buffer, 7);
    rs232.RS232LeerBytes(1);
}


/**
 * <p>Mtodo para utilizar un Timer controlado por Hardware en Modo 3.<p>
 * 
 * <p>Pines en Symbhia:
   <p>DISPARO EXTERNO  A5 -> NOTIFICACIN  B3<p>
   <p>DISPARO EXTERNO  A6 -> NOTIFICACIN  A3<p>
   <p>DISPARO EXTERNO  C6 -> NOTIFICACIN  A4<p>
   <p>DISPARO EXTERNO  A7 -> NOTIFICACIN  B5<p>
   
   <p>Pines en Avanxe verde:<p>  
   <p>DISPARO EXTERNO  E13 -> NOTIFICACIN  M16<p>
   <p>DISPARO EXTERNO  E15 -> NOTIFICACIN  C16<p>
   <p>DISPARO EXTERNO  F13 -> NOTIFICACIN  D16<p>
   <p>DISPARO EXTERNO  F14 -> NOTIFICACIN  E12<p>
    
   <p>Pines en Avanxe azul:<p>
   <p>DISPARO EXTERNO  E15 -> NOTIFICACIN  C13<p>
   <p>DISPARO EXTERNO  A14 -> NOTIFICACIN  D12<p>
   <p>DISPARO EXTERNO  F16 -> NOTIFICACIN  B12<p>
   <p>DISPARO EXTERNO  F15 -> NOTIFICACIN  A11<p>
 * @param PinFPGA - Pin de la FPGA utilizado como disparador externo
 * @param Tiempo - Tiempo que deber transcurrir antes de mandar la notificacin
 * @param Escala_Tiempo - Escala del tiempo en microsegundos (us), milisegundos (ms), segundos(s)
 * @param Ancho - Tiempo que durar la notificacin activa antes de reiniciar el Timer
 * @param Escala_Ancho - Escala de Ancho en microsegundos (us), milisegundos (ms), segundos(s)
 * @return <p>byte[0] - Almacena la notificacin del Timer (manda 1 cuando haya finalizado)<p> <p>byte[1] - Manda 1 cuando detecte el disparo externo<p>
 */
public byte[] Timer_Modo3(byte PinFPGA, int Tiempo, String Escala_Tiempo, int Ancho, String Escala_Ancho)
{
    int t = 0, a = 0;
    byte NotiPin = 0;
    switch (Escala_Tiempo)
    {
        case "us":
            t = Tiempo * 50;
            break;
        case "ms":
            t = Tiempo * 50000;
            break;
        case "s":
            t = Tiempo * 50000000;
            break;
    }
    
    byte[] Tbyte = ByteBuffer.allocate(4).putInt(t).array();

    switch (Escala_Ancho)
    {
        case "us":
            a = Ancho * 50;
            break;
        case "ms":
            a = Ancho * 50000;
            break;
        case "s":
            a = Ancho * 50000000;
            break;
    }
    
    byte[] Abyte = ByteBuffer.allocate(4).putInt(a).array();

    rs232.RS232EnviaBytes(new byte[] {PinFPGA,1}, 2);
    rs232.RS232LeerBytes(1);
    
    
    switch (PinFPGA)
    {
        case (byte)0x89:
            NotiPin = B3_Sy;
        break;

        case (byte)0x8A:
            NotiPin = A3_Sy;
        break;

        case (byte)0x8B:
            NotiPin = A4_Sy;
        break;

        case (byte)0x8C:
            NotiPin = B5_Sy;
        break;

        case (byte)0x8D:
            NotiPin = (byte)0x89;
        break;

        case (byte)0x8E:
            NotiPin = (byte)0x8A;
        break;

        case (byte)0x8F:
            NotiPin = (byte)0x8B;
        break;

        case (byte)0x90:
            NotiPin = (byte)0x8C;
        break;
    }
    
    byte[] Buffer = {NotiPin, 12, Tbyte[0], Tbyte[1], Tbyte[2], Tbyte[3], Abyte[0], Abyte[1], Abyte[2], Abyte[3] };
    rs232.RS232EnviaBytes(Buffer, 10);
    byte[] x = rs232.RS232LeerBytes(1);
    byte[] y = rs232.RS232LeerBytes(1);
    byte[] Dato = {x[0],y[0]};
    return Dato; 
}


/**
 * Utiliza este mtodo para utilizar el DAC como generador de funciones. Puedes seleccionar 1 de las 4 funciones disponibles.
 * @param Onda - Tipo de onda.
 * @param Frecuencia_Hz - Frecuencia en Hz.
 */
public void Generador_Funciones(String Onda, int Frecuencia_Hz)
{
    int ns = 0;
    int fs = 500000;

    switch (Onda)
    {
        case "Senoidal":

            if (Frecuencia_Hz > 499)
            {
                ns = (500000 / Frecuencia_Hz) - 1;
                byte[] ns_bytes = ByteBuffer.allocate(4).putInt(ns).array();
                byte[] Buffer = { comando_generador, 1, 0, 0, ns_bytes[2], ns_bytes[3] };
                rs232.RS232EnviaBytes(Buffer, 6);

                for (int i = 0; i <= ns; i++)
                {
                    double angle = (2 * Math.PI * Frecuencia_Hz * i) / fs;
                    double x = 1.65 + (1.65 * Math.sin(angle));
                    byte ndac = (byte)(Math.round((255 - ((x * 255) / 3.3))));
                    rs232.RS232EnviaBytes(new byte[] { ndac }, 1);
                }

            }
            else
            {
                ns = 999;
                fs = (50000000 / (Frecuencia_Hz * 1000)) - 1;
                byte[] ns_bytes = ByteBuffer.allocate(4).putInt(ns).array();
                byte[] fs_bytes = ByteBuffer.allocate(4).putInt(fs).array();
                byte[] Buffer = { comando_generador, 0, fs_bytes[2], fs_bytes[3], ns_bytes[2], ns_bytes[3] };
                rs232.RS232EnviaBytes(Buffer, 6);


                for (int i = 0; i <= ns; i++)
                {
                    double angle = (2.0 * Math.PI * i) / 1000;
                    double x = 1.65 + (1.65 * Math.sin(angle));
                    byte ndac = (byte)(Math.round((255 - ((x * 255) / 3.3))));
                    rs232.RS232EnviaBytes(new byte[] { ndac }, 1);
                }

            }

            break;

        case "DienteSierra":

            if (Frecuencia_Hz > 499)
            {
                ns = (500000 / Frecuencia_Hz) - 1;
                byte[] ns_bytes = ByteBuffer.allocate(4).putInt(ns).array();
                byte[] Buffer = { comando_generador, 1, 0, 0, ns_bytes[2], ns_bytes[3] };
                rs232.RS232EnviaBytes(Buffer, 6);
                double x = 0;
                for (int i = 0; i <= ns; i++)
                {
                    if (i <= ns)
                    {
                        x = 0.825 + (((4 * 0.825) / ns) * i - 0.825);
                    }
                    else
                    {
                        x = 0;
                    }

                    byte ndac = (byte)(Math.round((255 - ((x * 255) / 3.3))));
                    rs232.RS232EnviaBytes(new byte[] { ndac }, 1);
                }
            }
            else
            {
                ns = 999;
                fs = (50000000 / (Frecuencia_Hz * 1000)) - 1;
                byte[] ns_bytes = ByteBuffer.allocate(4).putInt(ns).array();
                byte[] fs_bytes = ByteBuffer.allocate(4).putInt(fs).array();
                byte[] Buffer = { comando_generador, 0, fs_bytes[2], fs_bytes[3], ns_bytes[2], ns_bytes[3] };
                rs232.RS232EnviaBytes(Buffer, 6);

                double x = 0;
                for (int i = 0; i <= ns; i++)
                {
                    if (i <= ns)
                    {
                        x = 0.825 + (((4 * 0.825) / ns) * i - 0.825);
                    }
                    else
                    {
                        x = 0;
                    }

                    byte ndac = (byte)(Math.round((255 - ((x * 255) / 3.3))));
                    rs232.RS232EnviaBytes(new byte[] { ndac }, 1);
                }
            }
            break;

        case "Cuadrada":

            if (Frecuencia_Hz > 499)
            {
                ns = (500000 / Frecuencia_Hz) - 1;
                byte[] ns_bytes = ByteBuffer.allocate(4).putInt(ns).array();
                byte[] Buffer = { comando_generador, 1, 0, 0, ns_bytes[2], ns_bytes[3] };
                rs232.RS232EnviaBytes(Buffer, 6);

                double x = 0;
                for (int i = 0; i <= ns; i++)
                {
                    if (i < (ns / 2))
                    {
                        x = 3.3;
                    }
                    else
                    {
                        x = 0;
                    }
                    byte ndac = (byte)(Math.round((255 - ((x * 255) / 3.3))));
                    rs232.RS232EnviaBytes(new byte[] { ndac }, 1);
                }

            }
            else
            {
                ns = 999;
                fs = (50000000 / (Frecuencia_Hz * 1000)) - 1;
                byte[] ns_bytes = ByteBuffer.allocate(4).putInt(ns).array();
                byte[] fs_bytes = ByteBuffer.allocate(4).putInt(fs).array();
                byte[] Buffer = { comando_generador, 0, fs_bytes[2], fs_bytes[3], ns_bytes[2], ns_bytes[3] };
                rs232.RS232EnviaBytes(Buffer, 6);

                double x = 0;
                for (int i = 0; i <= ns; i++)
                {
                    if (i <= ns / 2)
                    {
                        x = 3.3;
                    }
                    else
                    {
                        x = 0;
                    }

                    byte ndac = (byte)(Math.round((255 - ((x * 255) / 3.3))));
                    rs232.RS232EnviaBytes(new byte[] { ndac }, 1);
                }
            }
            break;

        case "Triangular":

            if (Frecuencia_Hz > 499)
            {
                ns = (500000 / Frecuencia_Hz) - 1;
                byte[] ns_bytes = ByteBuffer.allocate(4).putInt(ns).array();
                byte[] Buffer = { comando_generador, 1, 0, 0, ns_bytes[2], ns_bytes[3] };
                rs232.RS232EnviaBytes(Buffer, 6);

                double x = 0;
                for (int i = 0; i <= ns; i++)
                {
                    if (i <= ns / 2)
                    {
                        x = 1.65 + (((4 * 1.65) / ns) * i - 1.65);
                    }
                    else
                    {
                        x = 1.65 + (-(((4 * 1.65) / ns) * i) + (3 * 1.65));
                    }

                    byte ndac = (byte)(Math.round((255 - ((x * 255) / 3.3))));
                    rs232.RS232EnviaBytes(new byte[] { ndac }, 1);
                }
            }
            else
            {
                ns = 999;
                fs = (50000000 / (Frecuencia_Hz * 1000)) - 1;
                byte[] ns_bytes = ByteBuffer.allocate(4).putInt(ns).array();
                byte[] fs_bytes = ByteBuffer.allocate(4).putInt(fs).array();
                byte[] Buffer = { comando_generador, 0, fs_bytes[2], fs_bytes[3], ns_bytes[2], ns_bytes[3] };
                rs232.RS232EnviaBytes(Buffer, 6);

                double x = 0;
                for (int i = 0; i <= ns; i++)
                {
                    if (i <= ns / 2)
                    {
                        x = 1.65 + (((4 * 1.65) / ns) * i - 1.65);
                    }
                    else
                    {
                        x = 1.65 + (-(((4 * 1.65) / ns) * i) + (3 * 1.65));
                    }
                    byte ndac = (byte)(Math.round((255 - ((x * 255) / 3.3))));
                    rs232.RS232EnviaBytes(new byte[] { ndac }, 1);
                }
            }
            break;
    }
}




/**
 * Mtodo para inicializar la funcin que va a generar el usuario. Slo se requiere de la frecuencia de la seal a generar.
 * @param Frecuencia_Hz - Frecuencia de la seal a generar
 */
public void IniFuncion (int Frecuencia_Hz)
{
    int ns = 0;
    int fs = 500000;

    if (Frecuencia_Hz > 499)
    {
        ns = (500000 / Frecuencia_Hz) - 1;
        byte[] ns_bytes = ByteBuffer.allocate(4).putInt(ns).array();
        byte[] Buffer = { comando_generador, 1, 0, 0, ns_bytes[2], ns_bytes[3] };
        rs232.RS232EnviaBytes(Buffer, 6);
    }
    else
    {
        ns = 999;
        fs = (50000000 / (Frecuencia_Hz * 1000)) - 1;
        byte[] ns_bytes = ByteBuffer.allocate(4).putInt(ns).array();
        byte[] fs_bytes = ByteBuffer.allocate(4).putInt(fs).array();
        byte[] Buffer = { comando_generador, 0, fs_bytes[2], fs_bytes[3], ns_bytes[2], ns_bytes[3] };
        rs232.RS232EnviaBytes(Buffer, 6);
    }

}


/**
 * Mtodo para enviar las muestras de la funcin.
 Se debe colocar dentro de un ciclo de repeticin en donde las iteraciones debern coincidir 
 con el nmero de muestras que se estn enviando. Por ejemplo:
 Si requiero de 250 muestras para generar una funcin, entonces las iteraciones debern ir de 0 a 249.
 * @param Muestra - Valor de la muestra, debe ir de 0 a 3.3
 */
public void MandarMuestras(double Muestra)
{
    byte ndac = (byte)(Math.round((255 - ((Muestra * 255) / 3.3))));
    rs232.RS232EnviaBytes(new byte[] { ndac }, 1);
}


/**
 * Calcula la frecuencia de muestreo a partir de la frecuencia de la funcin a generar.
 * @param FrecuenciaHz - Frecuencia en Hertz
 * @return Valor de la frecuencia de muestreo
 */
public int Calcular_Fs(int FrecuenciaHz)
{
    int fs = 0;

    if (FrecuenciaHz > 499)
        fs = 500000;
    else
        fs = FrecuenciaHz * 1000;

    return fs;
}


/**
 * Mtodo que calcula el nmero de muestras a partir de la frecuencia de la funcin a generar
 * @param FrecuenciaHz - Frecuencia de la seal en Hertz
 * @return Nmero de muestras
 */
public int Calcular_Muestras(int FrecuenciaHz)
{
    int ns = 0;
    if (FrecuenciaHz > 499)
        ns = (500000 / FrecuenciaHz); 
    else
        ns = 1000;

    return ns;
}

    
}


